# Analysis pipeline

## Workflow

0. Setup a project folder in this directory.
1. Generate parameter files in project folder.
   If the project folder's name is `testproject`, then the parameter files must be named
   `testproject_1.toml, testproject_2.toml, ...`.
2. Run projects.
3. Analyze projects.

Step 1. should be done manually. Use `gather_parameters` to examine which parameter files are
already present.
Step 2. and 3. can be partly automated:
- Write a function `run_simulation(toml)` and pass it to `dg1d.run_projects`,
- Write a funnction `analyze_simulation(dir)` and pass it to `dg1d.analyze_projects`.
See `help` for additional flags.

Note: `run_simulation` should accpet a path to a `toml` file whereas `analyze_simulation`
should accept the path to an output directory (e.g. generated from a call to `run_simulation`).

## Advices

- Avoid duplicated parameter files for obvious reasons.

- In `analyze_simulation`, you should parse the `.toml` file inside the received directory 
(and not the one located in the parent directory, because it could already have become out of
sync). 

## Ideas

- Add method to merge some `base_parameters.toml` parameters with specialized parameters,
where the latter overwrite from the base.

- Add method to check if parameter files are in sync with any parameter files in output folders.
