abstract type AbstractHRSC end


function make_HRSC(parameters, mesh)
  type = Symbol(query(parameters, "type", default=missing))
  concretes = [ Base.typename(ct).name for ct in concretetypes(AbstractHRSC) ]
  if type === :missing
    return nothing
  end
  @assert type in concretes "HRSC parameter 'type = $type' unknown. Available options: $concretes"
  hrsc_type = eval(type)
  hrsc_parameters = parse_parameters(hrsc_type, parameters)
  hrsc = hrsc_type(; mesh, hrsc_parameters...)
  smoothav = query(parameters, "smoother", default=missing)
  if hrsc isa AbstractArtificialViscosity && smoothav !== missing
    order = query(Int64, parameters, "smoother_order", default=1)
    return SmoothedArtificialViscosity(mesh, hrsc, smoother_order=order)
  end
  return hrsc
end
