function make_BoundaryConditions_equation(rhs::RHS, prms)
  type = query(String, prms, "type")

  lhs_bc, rhs_bc = @match type begin
    "periodic"     => (PeriodicBC(), PeriodicBC())
    "no inflow"    => (DirichletBC((0.0,)), OutflowBC())
    "initial data" => begin
      @unpack u = get_dynamic_variables(rhs.cache)
      u_lhs, u_rhs = deepcopy(u[1]), deepcopy(u[end])
      lhs_bdry = t -> (u_lhs,)
      rhs_bdry = t -> (u_rhs,)
      DirichletBC(lhs_bdry), DirichletBC(rhs_bdry)
    end
    _              => error("Boundary condition type '$type' not implemented!")
  end
  
  return BoundaryConditions(lhs_bc, rhs_bc, rhs.rsolver)
end


function make_BoundaryConditions_LDG(ldg_rsolver, prms)
  isnothing(ldg_rsolver) && return nothing
  type = query(String, prms, "type")
  lhs_bc, rhs_bc = if type == "periodic"
    PeriodicBC(), PeriodicBC()
  else
    OutflowBC(), OutflowBC()
  end
  return BoundaryConditions(lhs_bc, rhs_bc, ldg_rsolver)
end
